=== debian/changelog ===
efivar (37-6ubuntu2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:11:08 +0200

efivar (37-6ubuntu1) hirsute; urgency=medium

  * Ignore stringop-truncation warnings in text_to_guid, seen when building
    with lto.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 29 Mar 2021 12:59:06 +0200

efivar (37-6) unstable; urgency=medium

  [ dann frazier ]
  * Add support for nvme-fabrics and nvme-subsystem devices. LP: #1891718.

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 16 Nov 2020 18:37:50 -0600

efivar (37-5) unstable; urgency=medium

  * Cherrypick upstream patch to enable CET on amd64.
  * Cherrypick upstream patch to fix uninitialized variable in
    parse_acpi_root(), which can lead to a segfault when calling
    grub-install. LP: #1892792.

 -- dann frazier <dannf@debian.org>  Mon, 24 Aug 2020 12:18:22 -0600

efivar (37-4) unstable; urgency=medium

  [ dann frazier ]
  * Fix FTBFS with GCC-10. (Closes: #966915)

  [ Ryan Finnie ]
  * Enable riscv64 build. (Closes: #959499)

  [ dann frazier ]
  * Bump debhelper compat to 12.

 -- dann frazier <dannf@debian.org>  Wed, 19 Aug 2020 07:12:28 -0600

efivar (37-3) unstable; urgency=medium

  [ Mario Limonciello ]
  * Drop Jared from uploaders.

  [ dann frazier ]
  * Backport changes from upstream to fix efibootmgr -v output.
    (Closes: #963475)

 -- Mario Limonciello <mario.limonciello@dell.com>  Tue, 18 Aug 2020 14:55:25 -0500

efivar (37-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: added upstream patches fix-gcc9-werror-format-guid.patch
    and fix-gcc9-werrors.patch to fix FTBFS with GCC 9. Thanks to Matthias
    Klose <doko@ubuntu.com>. (Closes: #925672)

 -- David da Silva Polverari <david.polverari@gmail.com>  Tue, 09 Jun 2020 17:31:58 -0500

efivar (37-2) unstable; urgency=medium

  * Cherry-pick fix from upstream:
    + Get rid of the arrows in our debug messages. (Closes: #922680)

 -- Steve McIntyre <93sam@debian.org>  Fri, 01 Mar 2019 17:55:07 +0000

efivar (37-1) unstable; urgency=medium

  * New upstream version (37)
  * debian/rules:
    - Correct for new Makefile variables.

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 05 Dec 2018 20:33:40 -0600
