=== debian/changelog ===
efivar (38-3.1deepin1) unstable; urgency=medium

  * Revert t64 and build=any.

 -- xiangzelong <xiangzelong@deepin.org>  Fri, 10 Jan 2025 14:33:41 +0800

efivar (38-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062526

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 02:57:40 +0000

efivar (38-3) unstable; urgency=medium

  [ Mate Kukri ]
  * d/p/0001-linux-handle-non-ACPI-systems-in-device_get.patch:
    Rebase on current upstream version and include in series

 -- Steve McIntyre <93sam@debian.org>  Wed, 29 Nov 2023 14:30:24 +0000

efivar (38-2) unstable; urgency=medium

  * Don't compile with -march=native. Closes: #1055123

 -- Steve McIntyre <93sam@debian.org>  Wed, 01 Nov 2023 00:39:42 +0000

efivar (38-1) unstable; urgency=medium

  [ Mario Limonciello ]
  * New upstream version (38)
  * Drop all patches, upstream
  * debian/*:
    - Create new binary packages for new library libefisec1
    - Add efisecdb to efivar binary package
  * debian/control:
    - Add mandoc to build depends
    - add grub-common to build depends for unit tests
  * debian/rules:
    - disable link time optimization to fix FTBFS
    - turn off verbose builds by default
    - set prefix for *-editenv command for unit tests

  [ Steve McIntyre ]
  * Add loong64 to arch lists for packages. Closes: #1055083

 -- Steve McIntyre <93sam@debian.org>  Tue, 31 Oct 2023 11:40:31 +0000
