=== debian/control ===
Source: efivar
Priority: optional
Maintainer: Debian UEFI Maintainers <debian-efi@lists.debian.org>
Uploaders: Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libpopt-dev, pkg-config, mandoc, grub-common
Standards-Version: 4.1.1
Section: libs
Homepage: https://github.com/rhinstaller/efivar
Vcs-Git: https://salsa.debian.org/efi-team/efivar.git
Vcs-Browser: https://salsa.debian.org/efi-team/efivar

Package: libefivar-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefivar1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefivar
 development headers required to use libefivar

Package: libefiboot-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefiboot1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefiboot
 development headers required to use libefiboot

Package: libefisec-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libefisec1 (= ${binary:Version}), ${misc:Depends}
Description: Development headers for libefisec
 development headers required to use libefisec

Package: efivar
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libefivar1 (= ${binary:Version}), libefiboot1 (= ${binary:Version})
Description: Tools to manage UEFI variables
 efivar provides a simple command line interface to the UEFI variable facility.

Package: libefiboot1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the manipulation of UEFI variables related to booting.

Package: libefivar1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables.

Package: libefisec1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: efibootmgr (<< 0.12-2)
Description: Library to manage UEFI variables
 Library to allow for the simple manipulation of UEFI variables related to
 security.
