=== debian/changelog ===
efivar (39-2) unstable; urgency=medium

  * Add s390x and ppc64el to architectures
  * Backport a patch from upstream to enable storing variables on ESP.
    (Closes: #1102494)

 -- Mario Limonciello <superm1@debian.org>  Tue, 19 Aug 2025 22:54:25 -0500

efivar (39-1) unstable; urgency=medium

  * d/watch: update
  * Drop upstream patch
  * Refresh no_host_march patch
  * d/control: Update standards version
  * d/control: update my email
  * d/control: b-d on pkgconf instead of pkg-config
  * Add salsa-ci.yml
  * Correct upstream address information

 -- Mario Limonciello <superm1@debian.org>  Mon, 18 Aug 2025 14:49:44 -0500
